#!/usr/bin/python3.8

# code below inspired from https://aws.amazon.com/fr/premiumsupport/knowledge-center/sns-lambda-webhooks-chime-slack-teams/

import urllib3
import json
import os
from string import Template
http = urllib3.PoolManager()

def lambda_handler(event, context):
    url = os.getenv("SLACK_WEBHOOK_URL")
    print(json.dumps(event))
    #get all messages in dict format
    messages = [json.loads(r.get('Sns',{}).get('Message','{}')) for r in event.get('Records',[])]
    text = []
    template = Template("\
ALARM - Details :\n\
\t- Name : $AlarmName \n\
\t- Description : $AlarmDescription \n\
\t- New State : $NewStateValue \n\
\t- Reason : $NewStateReason \n\
\t- Time : $StateChangeTime \n")

    for message in messages:
        text.append(template.substitute(message))

    print("Number of messages : " +str(len(text)))
    msg = {
        "text": "\n-------\n".join(text)
    }
    
    encoded_msg = json.dumps(msg).encode('utf-8')
    resp = http.request('POST',url, body=encoded_msg)
    ret = json.dumps({
        "body": {"messages":messages},
        "status_code": resp.status,
        "response": resp.data.decode("utf-8")
    })
    print(ret)
    return ret